package com.caimei365.wechat.dao;

import com.caimei365.wechat.entity.WechatArticleDetail;
import com.caimei365.wechat.entity.WechatReply;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * Description
 *
 * @author : Charles
 * @date : 2022/1/13
 */
@Mapper
public interface WeChatDao {
    /**
     * 根据参数匹配数据库回复配置
     * @param msgType 回复类型
     * @param keyword 关键词
     * @param wxType  微信Id
     */
    WechatReply getReplyByParams(String msgType, String keyword, String wxType);

    /**
     * 根据图文ID获取详情列表
     */
    List<WechatArticleDetail> getArticleDetailList(Integer articleId);

    /**
     * 根据ID获取文本内容
     */
    String getTextContent(Integer id);
}
